

// one simulation element, e.g. one job for a machine to process

public class JSElt  

{  
   // removes head of event list and assigns JSSim.JSCurrEvnt to it
   public static void JSGetNext()

   {  JSElt OldSchedListHd;

      OldSchedListHd  = JSSim.JSSchedListHd;
      if (JSSim.JSSchedListHd.JSNext == null)
         JSSim.JSSchedListHd = null;
      else JSSim.JSSchedListHd = JSSim.JSSchedListHd.JSNext;
      JSSim.JSCurrEvnt = OldSchedListHd;
   }

   // removes earliest element in event list having JSEltNum value EN
   public static void JSCancel(int EN)

   {  JSElt TmpEltPtr = JSSim.JSSchedListHd;

      if (TmpEltPtr == null) return;

      if (TmpEltPtr.JSEltNumber == EN)  {
         JSSim.JSSchedListHd = TmpEltPtr.JSNext;
         return;
      }

      while (TmpEltPtr.JSNext != null)  {
         if (TmpEltPtr.JSNext.JSEltNumber == EN)  {
            TmpEltPtr.JSNext = TmpEltPtr.JSNext.JSNext;
            return;
         }
         TmpEltPtr = TmpEltPtr.JSNext;   
      }
   
   }

   // checks for specified event type
   boolean JSEvntMatch(String S)

   {  return (JSSim.JSCurrEvnt.JSName.equals(S)); }

   // instance variables and functions

   public String JSName;  // name, for debugging purposes
   public float JSEvntTime;  // event occurrence time
   public int JSEltNumber;  // ID number
   public JSElt JSNext;  // pointer to next in event list
   
   // constructor function
   public JSElt() {  JSEltNumber = JSSim.JSNextNew++; }

   // insert this element into schedule list
   public void JSInsertInSchedList()  

   {  JSElt Tmp;

      JSNext = null;  // make sure no loose ends

      if (JSSim.JSSchedListHd == null)  {
         JSSim.JSSchedListHd = this;
         return;
      }

      if (JSEvntTime < JSSim.JSSchedListHd.JSEvntTime)  {
         JSNext = JSSim.JSSchedListHd;
         JSSim.JSSchedListHd = this;
         return;
      }

      Tmp = JSSim.JSSchedListHd;
      while (true) {
         if (Tmp.JSNext == null)  {
            Tmp.JSNext = this;
            break;
         }
         else if (JSEvntTime < Tmp.JSNext.JSEvntTime)  {
            JSNext = Tmp.JSNext;
            Tmp.JSNext = this;
            break;
         }
         Tmp = Tmp.JSNext;
      }
   }

   public void JSPrintElt()

   {  System.out.println("JSElt "+this.JSEltNumber+":  "
           +this.JSName+" at "+this.JSEvntTime);
   }
      
}



